/* query to create database demos and table student */
create database demos;
use demos;
create table student (rollno int, name varchar(20), gender varchar(1));

/* query to insert rows in the table */
/* Here's the sample data. You can change the data accordingly. */
insert into student values(1,'alex','m');
insert into student values(12,'tina','f');
insert into student values(22,'amex','m');

/* use select statement to see what has been inserted into the table */
select * from student;

/* use of case statement */
select rollno, name, case 
when gender='m' then 'MALE'
when gender='f' then 'FEMALE'
else 'not valid'
end as genderDetail
from student;

/* case with update statement */
update student 
set gender = CASE gender
WHEN 'm' THEN 'M'
when 'f' THEN 'F'
else 'NOT VALID'
end;

/* to view the update */
select * from student;

/* case with group by clause */
SELECT CASE
WHEN rollno>=10 THEN 'BACK SEAT'
WHEN rollno<10 THEN 'FRONT SEAT'
END as 'seat',
count(*) as NumberOfStudents
from student
GROUP BY
CASE
WHEN rollno>=10 THEN 'BACK SEAT'
WHEN rollno<10 THEN 'FRONT SEAT'
END;

/* case with order by clause */
select rollno, name, gender from student
ORDER BY CASE gender
WHEN 'F' THEN rollno end DESC,
CASE WHEN gender='M' THEN name 
END;

/* insert more data */
insert into student values(100,'Allen','m');
insert into student values(122,'Amy','f');
insert into student values(221,'Arun','m');
/* case with having clause */

SELECT Gender,  COUNT(*)
FROM student
GROUP BY Gender
HAVING COUNT(*) >
  CASE
    WHEN Gender = 'M'    THEN 4
    ELSE 1
  END;